package testw32apianno;
import utildll.*;
public class TestW32API6 {

	public static void main(String[] args) {
		new TestW32API6();
	}
	
	TestW32API6() {
		int intRtnVal;

		Struct_TIME_ZONE_INFORMATION stzi = new Struct_TIME_ZONE_INFORMATION();

		Arg_GetTimeZoneInformation agtzi = new Arg_GetTimeZoneInformation(stzi);
		
		intRtnVal = JInvoker.callIntProc("GetTimeZoneInformation", "kernel32", agtzi);

		System.out.println("GetTimeZoneInformation rtn: " + Integer.toString(intRtnVal)
				+ " LastError:" + Integer.toString(agtzi.getLastError()));
		System.out.println("Bias: " + Integer.toString(stzi.Bias));
		System.out.println("StandardName:" + new String(stzi.StandardName));
		System.out.println("StandardDate:" + Short.toString(stzi.StandardDate.wYear)
				+ "/" + Short.toString(stzi.StandardDate.wMonth)
				+ "/" + Short.toString(stzi.StandardDate.wDay)
				+ " " + Short.toString(stzi.StandardDate.wHour)
				+ ":" + Short.toString(stzi.StandardDate.wMinute)
				+ ":" + Short.toString(stzi.StandardDate.wSecond));
		System.out.println("StandardBias: " + Integer.toString(stzi.StandardBias));
		
		System.out.println("DaylightName:" + new String(stzi.DaylightName));
		System.out.println("DaylightDate:" + Short.toString(stzi.DaylightDate.wYear)
				+ "/" + Short.toString(stzi.DaylightDate.wMonth)
				+ "/" + Short.toString(stzi.DaylightDate.wDay)
				+ " " + Short.toString(stzi.DaylightDate.wHour)
				+ ":" + Short.toString(stzi.DaylightDate.wMinute)
				+ ":" + Short.toString(stzi.DaylightDate.wSecond));
		System.out.println("DaylightBias: " + Integer.toString(stzi.DaylightBias));

	
		Struct_TIME_ZONE_INFORMATION2 stzi2 = new Struct_TIME_ZONE_INFORMATION2();

		Arg_GetTimeZoneInformation2 agtzi2 = new Arg_GetTimeZoneInformation2(stzi2);
		
		intRtnVal = JInvoker.callIntProc("GetTimeZoneInformation", "kernel32", agtzi2);

		System.out.println("GetTimeZoneInformation rtn: " + Integer.toString(intRtnVal)
				+ " LastError:" + Integer.toString(agtzi2.getLastError()));
		System.out.println("Bias: " + Integer.toString(stzi2.Bias));
		System.out.println("StandardName:" + new String(stzi2.NameDateBias[0].Name));
		System.out.println("StandardDate:" + Short.toString(stzi2.NameDateBias[0].Date.wYear)
				+ "/" + Short.toString(stzi2.NameDateBias[0].Date.wMonth)
				+ "/" + Short.toString(stzi2.NameDateBias[0].Date.wDay)
				+ " " + Short.toString(stzi2.NameDateBias[0].Date.wHour)
				+ ":" + Short.toString(stzi2.NameDateBias[0].Date.wMinute)
				+ ":" + Short.toString(stzi2.NameDateBias[0].Date.wSecond));
		System.out.println("StandardBias: " + Integer.toString(stzi2.NameDateBias[0].Bias));
		
		System.out.println("StandardName:" + new String(stzi2.NameDateBias[1].Name));
		System.out.println("StandardDate:" + Short.toString(stzi2.NameDateBias[1].Date.wYear)
				+ "/" + Short.toString(stzi2.NameDateBias[1].Date.wMonth)
				+ "/" + Short.toString(stzi2.NameDateBias[1].Date.wDay)
				+ " " + Short.toString(stzi2.NameDateBias[1].Date.wHour)
				+ ":" + Short.toString(stzi2.NameDateBias[1].Date.wMinute)
				+ ":" + Short.toString(stzi2.NameDateBias[1].Date.wSecond));
		System.out.println("StandardBias: " + Integer.toString(stzi2.NameDateBias[1].Bias));

	}
	
	/*
	DWORD GetTimeZoneInformation(
	  LPTIME_ZONE_INFORMATION lpTimeZoneInformation // ^C][
	);
	 */
	class Arg_GetTimeZoneInformation {
		private int _LastError;
		
		private Struct_TIME_ZONE_INFORMATION lpTimeZoneInformation;
		
		Arg_GetTimeZoneInformation(Struct_TIME_ZONE_INFORMATION lpTimeZoneInformation) {
			this.lpTimeZoneInformation = lpTimeZoneInformation;
		}
		int getLastError() {return _LastError;}
	}
	
	/*
	typedef struct _TIME_ZONE_INFORMATION { 
	    LONG       Bias; 
	    WCHAR      StandardName[ 32 ]; 
	    SYSTEMTIME StandardDate; 
	    LONG       StandardBias; 
	    WCHAR      DaylightName[ 32 ]; 
	    SYSTEMTIME DaylightDate; 
	    LONG       DaylightBias; 
	} TIME_ZONE_INFORMATION
	 */
	class Struct_TIME_ZONE_INFORMATION {
		int Bias;
		@_Fixed char[] StandardName = new char[32];
		@_Fixed Struct_SYSTEMTIME StandardDate = new Struct_SYSTEMTIME();
		int StandardBias;
		@_Fixed char[] DaylightName = new char[32];
		@_Fixed Struct_SYSTEMTIME DaylightDate = new Struct_SYSTEMTIME();
		int DaylightBias;
	}
	
	/*
	typedef struct _SYSTEMTIME { 
	    WORD wYear; 
	    WORD wMonth; 
	    WORD wDayOfWeek; 
	    WORD wDay; 
	    WORD wHour; 
	    WORD wMinute; 
	    WORD wSecond; 
	    WORD wMilliseconds; 
	} SYSTEMTIME
	 */
	class Struct_SYSTEMTIME {
		short wYear;
		short wMonth;
		short wDayOfWeek;
		short wDay;
		short wHour;
		short wMinute;
		short wSecond;
		short wMilliseconds;
	}

	/*
	DWORD GetTimeZoneInformation(
	  LPTIME_ZONE_INFORMATION lpTimeZoneInformation // ^C][
	);
	 */
	class Arg_GetTimeZoneInformation2 {
		private int _LastError;
		
		private Struct_TIME_ZONE_INFORMATION2 lpTimeZoneInformation;
		
		Arg_GetTimeZoneInformation2(Struct_TIME_ZONE_INFORMATION2 lpTimeZoneInformation) {
			this.lpTimeZoneInformation = lpTimeZoneInformation;
		}
		int getLastError() {return _LastError;}
	}
	
	/*
	typedef struct _TIME_ZONE_INFORMATION { 
	    LONG       Bias; 
	    WCHAR      StandardName[ 32 ]; 
	    SYSTEMTIME StandardDate; 
	    LONG       StandardBias; 
	    WCHAR      DaylightName[ 32 ]; 
	    SYSTEMTIME DaylightDate; 
	    LONG       DaylightBias; 
	} TIME_ZONE_INFORMATION
	 */
	class Struct_TIME_ZONE_INFORMATION2 {
		int Bias;
		@_Fixed Struct_TIME_ZONE_NameDateBias[] NameDateBias =
			{new Struct_TIME_ZONE_NameDateBias(), new Struct_TIME_ZONE_NameDateBias()};
	}
	
	class Struct_TIME_ZONE_NameDateBias {
		@_Fixed char[] Name = new char[32];
		@_Fixed Struct_SYSTEMTIME Date = new Struct_SYSTEMTIME();
		int Bias;
	}
}
