package testw32apianno;
import utildll.*;
public class TestW32API9 {

	public static void main(String[] args) {
		new TestW32API9();
	}
	
	TestW32API9() {
		Struct_MEMORYSTATUSEX smse = new Struct_MEMORYSTATUSEX();

		Arg_sizeof aso = new Arg_sizeof(smse);
		
		smse.dwLength = (int)JInvoker.sizeof(aso);
		
		System.out.println("sizeof rtn: " + Integer.toString(smse.dwLength)
				+ " LastError: " + Integer.toString(aso.getLastError()));
		
		Arg_GlobalMemoryStatusEx agmse = new Arg_GlobalMemoryStatusEx(smse);
		
		boolean blRtnVal = JInvoker.callBooleanProc("GlobalMemoryStatusEx", "kernel32", agmse);
		
		System.out.println("GlobalMemoryStatusEx rtn: " + Boolean.toString(blRtnVal)
				+ " LastError: " + Integer.toString(agmse.getLastError()));
		System.out.println("dwMemoryLoad: " + Integer.toString(smse.dwMemoryLoad));
		System.out.println("ullTotalPhys: " + Long.toString(smse.ullTotalPhys));
		System.out.println("ullAvailPhys: " + Long.toString(smse.ullAvailPhys));
		System.out.println("ullTotalPageFile: " + Long.toString(smse.ullTotalPageFile));
		System.out.println("ullAvailPageFile: " + Long.toString(smse.ullAvailPageFile));
		System.out.println("ullTotalVirtual: " + Long.toString(smse.ullTotalVirtual));
		System.out.println("ullAvailVirtual: " + Long.toString(smse.ullAvailVirtual));
		System.out.println("ullAvailExtendedVirtual: " + Long.toString(smse.ullAvailExtendedVirtual));
	}
	
	/*
	BOOL GlobalMemoryStatusEx(
	  LPMEMORYSTATUSEX lpBuffer   // 1 ̃Xe[^X\̂ւ̃|C^
	);
	 */
	class Arg_GlobalMemoryStatusEx {
		private int _LastError;
		
		private Struct_MEMORYSTATUSEX lpBuffer;

		Arg_GlobalMemoryStatusEx(Struct_MEMORYSTATUSEX lpBuffer) {
			this.lpBuffer = lpBuffer;
		}
		int getLastError() {return _LastError;}
	}
	
	/*
	typedef struct _MEMORYSTATUSEX {
	  DWORD dwLength; 
	  DWORD dwMemoryLoad; 
	  DWORDLONG ullTotalPhys; 
	  DWORDLONG ullAvailPhys; 
	  DWORDLONG ullTotalPageFile; 
	  DWORDLONG ullAvailPageFile; 
	  DWORDLONG ullTotalVirtual; 
	  DWORDLONG ullAvailVirtual; 
	  DWORDLONG ullAvailExtendedVirtual;
	} MEMORYSTATUSEX
	 */
	class Struct_MEMORYSTATUSEX {
		@_Const int dwLength; 
		int dwMemoryLoad; 
		long ullTotalPhys; 
		long ullAvailPhys; 
		long ullTotalPageFile; 
		long ullAvailPageFile; 
		long ullTotalVirtual; 
		long ullAvailVirtual; 
		long ullAvailExtendedVirtual;
	}
	
	class Arg_sizeof {
		private int _LastError;

		private @_Const Object obj;

		Arg_sizeof(Object obj) {
			this.obj = obj;
		}
		int getLastError() {return _LastError;}
	}
}