package testw32apinew;
import java.lang.Thread;
import javax.swing.JOptionPane;
import utildll.*;

public class TestW32API32 extends Thread{
	static final int CHARSET = Arg.UNICODE;
	//static final int CHARSET = Arg.ANSI; //s
	long pEventSink;
	
	public static void main(String[] args) {
		new TestW32API32();
	}
	
	TestW32API32() {
		Arg_CoInitializeEx acie = new Arg_CoInitializeEx(ObjBase_h.COINIT_MULTITHREADED);
		
		int intRtnVal = JInvoker.callIntProc("CoInitializeEx", "ole32", acie);

		System.out.println("CoInitializeEx rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(acie.getLastError()));
		
		if (WinError_h.SUCCEEDED(intRtnVal)){
			Struct_IID pclsid = new Struct_IID();
			Arg_CLSIDFromProgID acfp = new Arg_CLSIDFromProgID("InternetExplorer.Application", pclsid);
			
			intRtnVal = JInvoker.callIntProc("CLSIDFromProgID", "ole32", acfp);
			
			System.out.println("CLSIDFromProgID rtn: " + Integer.toHexString(intRtnVal)
					+ " LastError: " + Integer.toString(acfp.getLastError()));
			System.out.println("pclsid: " + pclsid.toString_IID());
			
			if (WinError_h.SUCCEEDED(intRtnVal)){
				long[] pWebBrowser2 = new long[1];
				Struct_IID IID_IWebBrowser2 = new Struct_IID(
						"d30c1661-cdaf-11d0-8a3e-00c04fc9e26e");
	
				Arg_CoCreateInstance acci = new Arg_CoCreateInstance(pclsid, 
						WTypes_h.CLSCTX_LOCAL_SERVER, IID_IWebBrowser2, pWebBrowser2);
				
				intRtnVal = JInvoker.callIntProc("CoCreateInstance", "ole32", acci);
				
				System.out.println("CoCreateInstance rtn: " + Integer.toHexString(intRtnVal)
						+ " LastError: " + Integer.toString(acci.getLastError())
						+ " ppv: " + Long.toHexString(pWebBrowser2[0])
						+ " ElapsedTime(ms): " + Integer.toString(acci.getElapsedTime())
						+ " ElapsedTimeQP(ms): " + Double.toString(acci.getElapsedTimeQP()));

				if (WinError_h.SUCCEEDED(intRtnVal)){
					long[] pConnectionPoint = new long[1];
					int[] pdwCookie = new int[1];
					Struct_pVtbl spvt = new Struct_pVtbl(new EventSink());
					Arg_allocObject aao = new Arg_allocObject(spvt);
					
					pEventSink = JInvoker.allocObject(aao);
					
					System.out.println("allocObject allocAdrs: " + Long.toHexString(pEventSink)
							+ " LastError: " + Integer.toString(aao.getLastError()));
					
					boolean blRtnVal = initEvent(pWebBrowser2[0], pEventSink, pConnectionPoint, pdwCookie);
					
					if (blRtnVal){
						Struct_IID IID_NULL = new Struct_IID();
						String[] names = {"Navigate2", "Visible", "ReadyState", "Busy", "Quit"};
						int[] dispidwb2 = new int[5];
						final int IDX_Navigate2 = 0, IDX_Visible = 1, IDX_ReadyState = 2,
							IDX_Busy = 3, IDX_Quit = 4;
						
						for (int i = 0; i < names.length; i++){
							int[] dispid = new int[1];
							Arg_GetIDsOfNames agion = new Arg_GetIDsOfNames(IID_NULL,
									new String[]{names[i]}, 1,
									WinNT_h.LOCALE_SYSTEM_DEFAULT, dispid);
							
							intRtnVal = JInvoker.callIntMethod(pWebBrowser2[0], OAIdl_h.OFFSET_GetIDsOfNames, agion);
							
							System.out.println("GetIDsOfNames rtn: " + Integer.toHexString(intRtnVal)
									+ " LastError: " + Integer.toString(agion.getLastError())
									+ " dispid " + names[i] + ": " + Integer.toHexString(dispid[0]));
							
							if (WinError_h.FAILED(intRtnVal)) break;
							dispidwb2[i] = dispid[0];
						}
						if (WinError_h.SUCCEEDED(intRtnVal)){
							Struct_DISPPARAMS pDispParams;
							Struct_VARIANT pVarResult;
							Struct_EXCEPINFO pExcepInfo;
							int[] puArgErr;
							
							//Visible(true);
							pDispParams = new Struct_DISPPARAMS(
									new Struct_VARIANT[]{new Struct_VARIANT(true)},
									new int[]{OAIdl_h.DISPID_PROPERTYPUT}, 1, 1);
							pExcepInfo = new Struct_EXCEPINFO();
							puArgErr = new int[1];
							Arg_Invoke ai = new Arg_Invoke(dispidwb2[IDX_Visible], IID_NULL,
									WinNT_h.LOCALE_SYSTEM_DEFAULT, (short)OleAuto_h.DISPATCH_PROPERTYPUT,
									pDispParams, null, pExcepInfo, puArgErr);
							
							intRtnVal = JInvoker.callIntMethod(pWebBrowser2[0], OAIdl_h.OFFSET_Invoke, ai);
							
							System.out.println("Invoke(Visible) rtn: " + Integer.toHexString(intRtnVal)
									+ " LastError: " + Integer.toString(ai.getLastError())
									+ " puArgErr: " + Integer.toHexString(puArgErr[0]));

							//Navigate2("http://www.google.co.jp");
							pDispParams = new Struct_DISPPARAMS(
									new Struct_VARIANT[]{new Struct_VARIANT("http://www.google.co.jp")},
									null, 1, 0);
							pExcepInfo = new Struct_EXCEPINFO();
							puArgErr = new int[1];
							ai = new Arg_Invoke(dispidwb2[IDX_Navigate2], IID_NULL,
									WinNT_h.LOCALE_SYSTEM_DEFAULT, (short)OleAuto_h.DISPATCH_METHOD,
									pDispParams, null, pExcepInfo, puArgErr);
							
							intRtnVal = JInvoker.callIntMethod(pWebBrowser2[0], OAIdl_h.OFFSET_Invoke, ai);
							
							System.out.println("Invoke(Navigate2) rtn: " + Integer.toHexString(intRtnVal)
									+ " LastError: " + Integer.toString(ai.getLastError())
									+ " puArgErr: " + Integer.toHexString(puArgErr[0]));

							do {
								try{
									sleep(1000);
								}
								catch(InterruptedException e){}
								//ReadyState();
								pDispParams = new Struct_DISPPARAMS(null, null, 0, 0);
								pVarResult = new Struct_VARIANT();
								pExcepInfo = new Struct_EXCEPINFO();
								puArgErr = new int[1];
								ai = new Arg_Invoke(dispidwb2[IDX_ReadyState], IID_NULL,
										WinNT_h.LOCALE_SYSTEM_DEFAULT, (short)OleAuto_h.DISPATCH_PROPERTYGET,
										pDispParams, pVarResult, pExcepInfo, puArgErr);
								
								intRtnVal = JInvoker.callIntMethod(pWebBrowser2[0], OAIdl_h.OFFSET_Invoke, ai);
								
								System.out.println("Invoke(ReadyState) rtn: " + Integer.toHexString(intRtnVal)
										+ " LastError: " + Integer.toString(ai.getLastError())
										+ " pVarResult vt: " + Integer.toHexString(pVarResult.vt)
										+ " lVal: " + Integer.toString(pVarResult.uvn3.lVal)
										+ " puArgErr: " + Integer.toHexString(puArgErr[0]));
								
							} while(pVarResult.uvn3.lVal != OCIdl_h.READYSTATE_COMPLETE);
							
							//Dialog
							JOptionPane.showMessageDialog(null, "Quit", "TestW32API32",
									JOptionPane.INFORMATION_MESSAGE);
							System.out.println("Quit Dialog term ");
							
							do {
								try{
									sleep(1000);
								}
								catch(InterruptedException e){}
								//ReadyState();
								pDispParams = new Struct_DISPPARAMS(null, null, 0, 0);
								pVarResult = new Struct_VARIANT();
								pExcepInfo = new Struct_EXCEPINFO();
								puArgErr = new int[1];
								ai = new Arg_Invoke(dispidwb2[IDX_ReadyState], IID_NULL,
										WinNT_h.LOCALE_SYSTEM_DEFAULT, (short)OleAuto_h.DISPATCH_PROPERTYGET,
										pDispParams, pVarResult, pExcepInfo, puArgErr);
								
								intRtnVal = JInvoker.callIntMethod(pWebBrowser2[0], OAIdl_h.OFFSET_Invoke, ai);
								
								System.out.println("Invoke(ReadyState) rtn: " + Integer.toHexString(intRtnVal)
										+ " LastError: " + Integer.toString(ai.getLastError())
										+ " pVarResult vt: " + Integer.toHexString(pVarResult.vt)
										+ " lVal: " + Integer.toString(pVarResult.uvn3.lVal)
										+ " puArgErr: " + Integer.toHexString(puArgErr[0]));
								
							} while(pVarResult.uvn3.lVal != OCIdl_h.READYSTATE_COMPLETE);

							//Quit();
							pDispParams = new Struct_DISPPARAMS(null, null, 0, 0);
							pExcepInfo = new Struct_EXCEPINFO();
							puArgErr = new int[1];
							ai = new Arg_Invoke(dispidwb2[IDX_Quit], IID_NULL,
									WinNT_h.LOCALE_SYSTEM_DEFAULT, (short)OleAuto_h.DISPATCH_METHOD,
									pDispParams, null, pExcepInfo, puArgErr);
							
							intRtnVal = JInvoker.callIntMethod(pWebBrowser2[0], OAIdl_h.OFFSET_Invoke, ai);
							
							System.out.println("Invoke(Quit) rtn: " + Integer.toHexString(intRtnVal)
									+ " LastError: " + Integer.toString(ai.getLastError())
									+ " puArgErr: " + Integer.toHexString(puArgErr[0]));
						}
						termEvent(pEventSink, pConnectionPoint, pdwCookie);
					}
					Arg_Release ar = new Arg_Release();
					
					intRtnVal = JInvoker.callIntMethod(pWebBrowser2[0], OAIdl_h.OFFSET_Release, ar);
					
					System.out.println("Release rtn: " + Integer.toHexString(intRtnVal)
							+ " LastError: " + Integer.toString(ar.getLastError()));
				}
			}
			JInvoker.callVoidProc("CoUninitialize", "ole32", null);
		}
	}
	
	boolean initEvent(long pUnknown, long pSink, long[] pConnectionPoint, int[] pdwCookie){
		boolean blRtnVal = false;
		Struct_IID IID_IConnectionPointContainer = new Struct_IID(
				"b196b284-bab4-101a-b69c-00aa00341d07");
		long[] pConnectionPointContainer = new long[1];
		
		Arg_QueryInterface aqi = new Arg_QueryInterface(IID_IConnectionPointContainer, pConnectionPointContainer);
		
		int intRtnVal = JInvoker.callIntMethod(pUnknown, OAIdl_h.OFFSET_QueryInterface, aqi);
		
		System.out.println("QueryInterface rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(aqi.getLastError())
				+ " ppvObject: " + Long.toHexString(pConnectionPointContainer[0]));

		if (WinError_h.SUCCEEDED(intRtnVal)){
			Struct_IID DIID_DWebBrowserEvents2 = new Struct_IID(
					"34a715a0-6587-11d0-924a-0020afc7ac4d");
			
			Arg_FindConnectionPoint afcp = new Arg_FindConnectionPoint(DIID_DWebBrowserEvents2, pConnectionPoint);
			
			intRtnVal = JInvoker.callIntMethod(pConnectionPointContainer[0], OCIdl_h.OFFSET_FindConnectionPoint, afcp);
			
			System.out.println("FindConnectionPoint rtn: " + Integer.toHexString(intRtnVal)
					+ " LastError: " + Integer.toString(afcp.getLastError())
					+ " ppCP: " + Long.toHexString(pConnectionPoint[0]));
			
			if (WinError_h.SUCCEEDED(intRtnVal)){
				Arg_Advise aa = new Arg_Advise(pSink, pdwCookie);
				
				intRtnVal = JInvoker.callIntMethod(pConnectionPoint[0], OCIdl_h.OFFSET_Advise, aa);
				
				System.out.println("Advise rtn: " + Integer.toHexString(intRtnVal)
						+ " LastError: " + Integer.toString(aa.getLastError())
						+ " pdwCookie: " + Integer.toHexString(pdwCookie[0]));
				
				if (WinError_h.SUCCEEDED(intRtnVal)) {
					blRtnVal = true;
				}
				else {
					Arg_Release ar = new Arg_Release();
					
					intRtnVal = JInvoker.callIntMethod(pConnectionPoint[0], OAIdl_h.OFFSET_Release, ar);
					
					System.out.println("Release pConnectionPoint rtn: " + Integer.toHexString(intRtnVal)
							+ " LastError: " + Integer.toString(ar.getLastError()));
				}
			}
			
			Arg_Release ar = new Arg_Release();
			
			intRtnVal = JInvoker.callIntMethod(pConnectionPointContainer[0], OAIdl_h.OFFSET_Release, ar);
			
			System.out.println("Release pConnectionPointContainer rtn: " + Integer.toHexString(intRtnVal)
					+ " LastError: " + Integer.toString(ar.getLastError()));
		}
		return blRtnVal;
	}
	
	void termEvent(long pSink, long[] pConnectionPoint, int[] pdwCookie){
		Arg_Unadvise au = new Arg_Unadvise(pdwCookie[0]);
		
		int intRtnVal = JInvoker.callIntMethod(pConnectionPoint[0], OCIdl_h.OFFSET_Unadvise, au);
		
		System.out.println("Unadvise rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(au.getLastError()));
		
		Arg_Release ar = new Arg_Release();
		
		intRtnVal = JInvoker.callIntMethod(pConnectionPoint[0], OAIdl_h.OFFSET_Release, ar);
		
		System.out.println("Release pConnectionPoint rtn: " + Integer.toHexString(intRtnVal)
				+ " LastError: " + Integer.toString(ar.getLastError()));
		
		intRtnVal = JInvoker.freeObject(pSink);
		
		System.out.println("freeObject intRtnVal: " + Integer.toString(intRtnVal));

	}
	
	class Struct_pVtbl{
		Struct_Vtbl pVtbl;
		
		Struct_pVtbl(Object _Instance){
			this.pVtbl = new Struct_Vtbl(_Instance);
		}
	}
	
	class Struct_Vtbl{
		@_FuncPtr Method_def pQueryInterface;
		@_FuncPtr Method_def pAddRef;
		@_FuncPtr Method_def pRelease;
		@_FuncPtr Method_def pGetTypeInfoCount;
		@_FuncPtr Method_def pGetTypeInfo;
		@_FuncPtr Method_def pGetIDsOfNames;
		@_FuncPtr Method_def pInvoke;
		
		Struct_Vtbl(Object _Instance){
			this.pQueryInterface = new Method_def("QueryInterface", Func.RTNTYPE_INT,
					new EventArg_QueryInterface(null, null), _Instance);
			this.pAddRef = new Method_def("AddRef", Func.RTNTYPE_INT,
					new EventArg_AddRef(), _Instance);
			this.pRelease = new Method_def("Release", Func.RTNTYPE_INT,
					new EventArg_Release(), _Instance);
			this.pGetTypeInfoCount = new Method_def("GetTypeInfoCount", Func.RTNTYPE_INT,
					new EventArg_GetTypeInfoCount(null), _Instance);
			this.pGetTypeInfo = new Method_def("GetTypeInfo", Func.RTNTYPE_INT,
					new EventArg_GetTypeInfo(0, 0, null), _Instance);
			this.pGetIDsOfNames = new Method_def("GetIDsOfNames", Func.RTNTYPE_INT,
					new EventArg_GetIDsOfNames(null, null, 0, 0, null), _Instance);
			this.pInvoke = new Method_def("Invoke", Func.RTNTYPE_INT,
					new EventArg_Invoke(0, null, 0, (short)0, null, null, null, null), _Instance);
		}
	}
	
	class EventSink {
		int QueryInterface(EventArg_QueryInterface aqi){
			Struct_IID IID_IDispatch = new Struct_IID(
					"00020400-0000-0000-c000-000000000046");
			Struct_IID IID_IUnknown = new Struct_IID(
					"00000000-0000-0000-c000-000000000046");

			if (aqi.iid.isEqualIID(IID_IDispatch)){
				if (aqi.ppvObject != null){
					if (aqi.ppvObject.length > 0){
						aqi.ppvObject[0] = pEventSink;
					}
				}
				System.out.println("[EventSink] QueryInterface(IID_IDispatch) called ");
				return WinError_h.S_OK;
			}
			else if (aqi.iid.isEqualIID(IID_IUnknown)){
				if (aqi.ppvObject != null){
					if (aqi.ppvObject.length > 0){
						aqi.ppvObject[0] = pEventSink;
					}
				}
				System.out.println("[EventSink] QueryInterface(IID_IUnknown) called ");
				return WinError_h.S_OK;
			}
			else {
				if (aqi.ppvObject != null){
					if (aqi.ppvObject.length > 0){
						aqi.ppvObject[0] = 0;
					}
				}
				System.out.println("[EventSink] QueryInterface(etc) called ");
				System.out.println("iid: " + aqi.iid.toString_IID());
				return WinError_h.E_NOINTERFACE;
			}
		}
		
		int AddRef(EventArg_AddRef aar){
			System.out.println("[EventSink] AddRef called ");
			return 1;
		}
		
		int Release(EventArg_Release ar){
			System.out.println("[EventSink] Release called ");
			return 1;
		}
		
		int GetTypeInfoCount(EventArg_GetTypeInfoCount agtic){
			System.out.println("[EventSink] GetTypeInfoCount called ");
			return WinError_h.E_NOTIMPL;
		}
		
		int GetTypeInfo(EventArg_GetTypeInfo agti){
			System.out.println("[EventSink] GetTypeInfo called ");
			return WinError_h.E_NOTIMPL;
		}
		
		int GetIDsOfNames(EventArg_GetIDsOfNames agion){
			System.out.println("[EventSink] GetIDsOfNames called ");
			return WinError_h.E_NOTIMPL;
		}
		
		int Invoke(EventArg_Invoke ai){
			switch(ai.dispIdMember){
			case ExDispid_h.DISPID_BEFORENAVIGATE:
				System.out.println("[EventSink] Invoke(DISPID_BEFORENAVIGATE) called");
				break;
			case ExDispid_h.DISPID_NAVIGATECOMPLETE:
				System.out.println("[EventSink] Invoke(DISPID_NAVIGATECOMPLETE) called");
				break;
			case ExDispid_h.DISPID_STATUSTEXTCHANGE:
				System.out.println("[EventSink] Invoke(DISPID_STATUSTEXTCHANGE) called");
				break;
			case ExDispid_h.DISPID_QUIT:
				System.out.println("[EventSink] Invoke(DISPID_QUIT) called");
				break;
			case ExDispid_h.DISPID_DOWNLOADCOMPLETE:
				System.out.println("[EventSink] Invoke(DISPID_DOWNLOADCOMPLETE) called");
				break;
			case ExDispid_h.DISPID_COMMANDSTATECHANGE:
				System.out.println("[EventSink] Invoke(DISPID_COMMANDSTATECHANGE) called");
				break;
			case ExDispid_h.DISPID_DOWNLOADBEGIN:
				System.out.println("[EventSink] Invoke(DISPID_DOWNLOADBEGIN) called");
				break;
			case ExDispid_h.DISPID_NEWWINDOW:
				System.out.println("[EventSink] Invoke(DISPID_NEWWINDOW) called");
				break;
			case ExDispid_h.DISPID_PROGRESSCHANGE:
				System.out.println("[EventSink] Invoke(DISPID_PROGRESSCHANGE) called");
				break;
			case ExDispid_h.DISPID_WINDOWMOVE:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWMOVE) called");
				break;
			case ExDispid_h.DISPID_WINDOWRESIZE:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWRESIZE) called");
				break;
			case ExDispid_h.DISPID_WINDOWACTIVATE:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWACTIVATE) called");
				break;
			case ExDispid_h.DISPID_PROPERTYCHANGE:
				System.out.println("[EventSink] Invoke(DISPID_PROPERTYCHANGE) called");
				break;
			case ExDispid_h.DISPID_TITLECHANGE:
				System.out.println("[EventSink] Invoke(DISPID_TITLECHANGE) called");
				break;
			case ExDispid_h.DISPID_TITLEICONCHANGE:
				System.out.println("[EventSink] Invoke(DISPID_TITLEICONCHANGE) called");
				break;
			case ExDispid_h.DISPID_FRAMEBEFORENAVIGATE:
				System.out.println("[EventSink] Invoke(DISPID_FRAMEBEFORENAVIGATE) called");
				break;
			case ExDispid_h.DISPID_FRAMENAVIGATECOMPLETE:
				System.out.println("[EventSink] Invoke(DISPID_FRAMENAVIGATECOMPLETE) called");
				break;
			case ExDispid_h.DISPID_FRAMENEWWINDOW:
				System.out.println("[EventSink] Invoke(DISPID_FRAMENEWWINDOW) called");
				break;
			case ExDispid_h.DISPID_BEFORENAVIGATE2:
				System.out.println("[EventSink] Invoke(DISPID_BEFORENAVIGATE2) called");
				break;
			case ExDispid_h.DISPID_NEWWINDOW2:
				System.out.println("[EventSink] Invoke(DISPID_NEWWINDOW2) called");
				break;
			case ExDispid_h.DISPID_NAVIGATECOMPLETE2:
				System.out.println("[EventSink] Invoke(DISPID_NAVIGATECOMPLETE2) called");
				break;
			case ExDispid_h.DISPID_ONQUIT:
				System.out.println("[EventSink] Invoke(DISPID_ONQUIT) called");
				break;
			case ExDispid_h.DISPID_ONVISIBLE:
				System.out.println("[EventSink] Invoke(DISPID_ONVISIBLE) called");
				break;
			case ExDispid_h.DISPID_ONTOOLBAR:
				System.out.println("[EventSink] Invoke(DISPID_ONTOOLBAR) called");
				break;
			case ExDispid_h.DISPID_ONMENUBAR:
				System.out.println("[EventSink] Invoke(DISPID_ONMENUBAR) called");
				break;
			case ExDispid_h.DISPID_ONSTATUSBAR:
				System.out.println("[EventSink] Invoke(DISPID_ONSTATUSBAR) called");
				break;
			case ExDispid_h.DISPID_ONFULLSCREEN:
				System.out.println("[EventSink] Invoke(DISPID_ONFULLSCREEN) called");
				break;
			case ExDispid_h.DISPID_DOCUMENTCOMPLETE:
				System.out.println("[EventSink] Invoke(DISPID_DOCUMENTCOMPLETE) called");
				break;
			case ExDispid_h.DISPID_ONTHEATERMODE:
				System.out.println("[EventSink] Invoke(DISPID_ONTHEATERMODE) called");
				break;
			case ExDispid_h.DISPID_ONADDRESSBAR:
				System.out.println("[EventSink] Invoke(DISPID_ONADDRESSBAR) called");
				break;
			case ExDispid_h.DISPID_WINDOWSETRESIZABLE:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWSETRESIZABLE) called");
				break;
			case ExDispid_h.DISPID_WINDOWCLOSING:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWCLOSING) called");
				break;
			case ExDispid_h.DISPID_WINDOWSETLEFT:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWSETLEFT) called");
				break;
			case ExDispid_h.DISPID_WINDOWSETTOP:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWSETTOP) called");
				break;
			case ExDispid_h.DISPID_WINDOWSETWIDTH:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWSETWIDTH) called");
				break;
			case ExDispid_h.DISPID_WINDOWSETHEIGHT:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWSETHEIGHT) called");
				break;
			case ExDispid_h.DISPID_CLIENTTOHOSTWINDOW:
				System.out.println("[EventSink] Invoke(DISPID_CLIENTTOHOSTWINDOW) called");
				break;
			case ExDispid_h.DISPID_SETSECURELOCKICON:
				System.out.println("[EventSink] Invoke(DISPID_SETSECURELOCKICON) called");
				break;
			case ExDispid_h.DISPID_FILEDOWNLOAD:
				System.out.println("[EventSink] Invoke(DISPID_FILEDOWNLOAD) called");
				break;
			case ExDispid_h.DISPID_NAVIGATEERROR:
				System.out.println("[EventSink] Invoke(DISPID_NAVIGATEERROR) called");
				break;
			case ExDispid_h.DISPID_PRIVACYIMPACTEDSTATECHANGE:
				System.out.println("[EventSink] Invoke(DISPID_PRIVACYIMPACTEDSTATECHANGE) called");
				break;
			case ExDispid_h.DISPID_NEWWINDOW3:
				System.out.println("[EventSink] Invoke(DISPID_NEWWINDOW3) called");
				break;
			case ExDispid_h.DISPID_VIEWUPDATE:
				System.out.println("[EventSink] Invoke(DISPID_VIEWUPDATE) called");
				break;
			case ExDispid_h.DISPID_SETPHISHINGFILTERSTATUS:
				System.out.println("[EventSink] Invoke(DISPID_SETPHISHINGFILTERSTATUS) called");
				break;
			case ExDispid_h.DISPID_WINDOWSTATECHANGED:
				System.out.println("[EventSink] Invoke(DISPID_WINDOWSTATECHANGED) called");
				break;
			default:
				System.out.println("[EventSink] Invoke(" + Integer.toString(ai.dispIdMember) + ")");
			}
			for (int i = ai.pDispParams.cArgs - 1; i >= 0 ; i--){
				System.out.print("param#" + Integer.toString(ai.pDispParams.cArgs - i)
						+ " vt: " + Integer.toHexString(ai.pDispParams.rgvarg[i].vt));
				switch (ai.pDispParams.rgvarg[i].vt){
				case WTypes_h.VT_I4:
					System.out.println(" VT_I4 " + Integer.toString(ai.pDispParams.rgvarg[i].uvn3.lVal));
					break;
				case WTypes_h.VT_BSTR:
					System.out.println(" VT_BSTR " + ai.pDispParams.rgvarg[i].uvn3.bstrVal);
					break;
				case WTypes_h.VT_DISPATCH:
					System.out.println(" VT_DISPATCH " + Long.toHexString(ai.pDispParams.rgvarg[i].uvn3.pdispVal));
					break;
				case WTypes_h.VT_BOOL:
					System.out.println(" VT_BOOL " + ((ai.pDispParams.rgvarg[i].uvn3.boolVal != 0) ? "true" : "false"));
					break;
				case WTypes_h.VT_BYREF | WTypes_h.VT_BOOL:
					System.out.println(" VT_BYREF | VT_BOOL " + ((ai.pDispParams.rgvarg[i].uvn3.pboolVal[0] != 0) ? "true" : "false"));
					break;
				case WTypes_h.VT_BYREF | WTypes_h.VT_VARIANT:
					System.out.print(" VT_BYREF | VT_VARIANT "
							+ " vt: " + Integer.toHexString(ai.pDispParams.rgvarg[i].uvn3.pvarVal.vt));
					switch (ai.pDispParams.rgvarg[i].uvn3.pvarVal.vt){
					case WTypes_h.VT_EMPTY:
						System.out.println(" VT_EMPTY ");
						break;
					case WTypes_h.VT_I4:
						System.out.println(" VT_I4 " + Integer.toString(ai.pDispParams.rgvarg[i].uvn3.pvarVal.uvn3.lVal));
						break;
					case WTypes_h.VT_BSTR:
						System.out.println(" VT_BSTR " + ai.pDispParams.rgvarg[i].uvn3.pvarVal.uvn3.bstrVal);
						break;
					case WTypes_h.VT_DISPATCH:
						System.out.println(" VT_DISPATCH " + Long.toHexString(ai.pDispParams.rgvarg[i].uvn3.pvarVal.uvn3.pdispVal));
						break;
					case WTypes_h.VT_BOOL:
						System.out.println(" VT_BOOL " + ((ai.pDispParams.rgvarg[i].uvn3.pvarVal.uvn3.boolVal != 0) ? "true" : "false"));
						break;
					case WTypes_h.VT_BYREF | WTypes_h.VT_BOOL:
						System.out.println(" VT_BYREF | VT_BOOL " + ((ai.pDispParams.rgvarg[i].uvn3.pvarVal.uvn3.pboolVal[0] != 0) ? "true" : "false"));
						break;
					case WTypes_h.VT_BYREF | WTypes_h.VT_VARIANT:
						System.out.print(" VT_BYREF | VT_VARIANT "
								+ " vt: " + Integer.toHexString(ai.pDispParams.rgvarg[i].uvn3.pvarVal.uvn3.pvarVal.vt));
						switch (ai.pDispParams.rgvarg[i].uvn3.pvarVal.uvn3.pvarVal.vt){
						case WTypes_h.VT_EMPTY:
							System.out.println(" VT_EMPTY ");
							break;
						default:
							System.out.println();
						}
						break;
					default:
						System.out.println();
					}
					break;
				default:
					System.out.println();
				}
			}
			for (int i = ai.pDispParams.cNamedArgs - 1; i >= 0 ; i--){
				System.out.println("DispID#" + Integer.toString(ai.pDispParams.cArgs - i)
						+ " " + Integer.toHexString(ai.pDispParams.rgdispidNamedArgs[i]));
			}
			return WinError_h.S_OK;
		}
	}
	
	class Method_def {
		private String _FuncName;
		private int _ReturnType;
		private Object _FuncArg;
		private Object _Instance;
		
		Method_def(String _FuncName, int _ReturnType, Object _FuncArg, Object _Instance){
			this._FuncName = _FuncName;
			this._ReturnType = _ReturnType;
			this._FuncArg = _FuncArg;
			this._Instance = _Instance;
		}
	}
	
	class Arg_property {
		private int _LastError;
	
		int getLastError() {return _LastError;}
	}

	class Arg_allocObject extends Arg_property {
		private Object obj;
		
		Arg_allocObject(Object obj) {
			this.obj = obj;
		}
	}
	
	class EventArg_property {
		private long _This;
	
		long getThis() {return _This;}
	}

	/*
	HRESULT QueryInterface( 
		REFIID iid, 
		void **ppvObject
	);
	 */
	class EventArg_QueryInterface extends EventArg_property {
		private @_In Struct_IID iid;
		private @_Out long[] ppvObject;
		
		EventArg_QueryInterface(Struct_IID iid, long[] ppvObject){
			this.iid = iid;
			this.ppvObject = ppvObject;
		}
	}
	
	/*
	ULONG AddRef( void );
	 */
	class EventArg_AddRef extends EventArg_property {
	}
	
	/*
	ULONG Release( void );
	 */
	class EventArg_Release extends EventArg_property {
	}
	
	/*
	HRESULT GetTypeInfoCount( 
		unsigned int FAR *pctinfo
	);
	 */
	class EventArg_GetTypeInfoCount extends EventArg_property {
		private @_Out int[] pctinfo;
		
		EventArg_GetTypeInfoCount(int[] pctinfo){
			this.pctinfo = pctinfo;
		}
	}
	
	/*
	HRESULT GetTypeInfo( 
		unsigned int iTInfo, 
		LCID lcid, 
		ITypeInfo FAR *FAR *ppTInfo
	);
	 */
	class EventArg_GetTypeInfo extends EventArg_property {
		private @_In int iTInfo;
		private @_In int lcid;
		private @_Out long[] ppTInfo;
		
		EventArg_GetTypeInfo(int iTInfo, int lcid, long[] ppTInfo){
			this.iTInfo = iTInfo;
			this.lcid = lcid;
			this.ppTInfo = ppTInfo;
		}
	}
	
	/*
	HRESULT GetIDsOfNames( 
		REFIID riid, 
		OLECHAR FAR *FAR *rgszNames, 
		unsigned int cNames, 
		LCID lcid, 
		DISPID FAR *rgDispId
	);
	 */
	@_CharSet(CHARSET)
	class EventArg_GetIDsOfNames extends EventArg_property {
		private @_In Struct_IID riid;
		private @_In String[] rgszNames;
		private @_In int cNames;
		private @_In int lcid;
		//private @_Out @_Length_is("cNames") int[] rgDispId;
		private @_Out int[] rgDispId;
		
		EventArg_GetIDsOfNames(Struct_IID riid, String[] rgszNames,
				int cNames, int lcid, int[] rgDispId){
			this.riid = riid;
			this.rgszNames = rgszNames;
			this.cNames = cNames;
			this.lcid = lcid;
			this.rgDispId = rgDispId;
		}
	}
	
	/*
	HRESULT Invoke( 
		DISPID dispIdMember, 
		REFIID riid,
		LCID lcid, 
		WORD wFlags, 
		DISPPARAMS FAR *pDispParams, 
		VARIANT FAR *pVarResult, 
		EXCEPINFO FAR *pExcepInfo, 
		unsigned int FAR *puArgErr
	);
	 */
	class EventArg_Invoke extends EventArg_property {
		private @_In int dispIdMember;
		private @_In Struct_IID riid;
		private @_In int lcid;
		private @_In short wFlags;
		private @_In Struct_DISPPARAMS pDispParams;
		private @_Out Struct_VARIANT pVarResult;
		private @_Out Struct_EXCEPINFO pExcepInfo;
		private @_Out int[] puArgErr;
		
		EventArg_Invoke(int dispIdMember, Struct_IID riid, int lcid, short wFlags,
				Struct_DISPPARAMS pDispParams, Struct_VARIANT pVarResult,
				Struct_EXCEPINFO pExcepInfo, int[] puArgErr){
			this.dispIdMember = dispIdMember;
			this.riid = riid;
			this.lcid = lcid;
			this.wFlags = wFlags;
			this.pDispParams = pDispParams;
			this.pVarResult = pVarResult;
			this.pExcepInfo = pExcepInfo;
			this.puArgErr = puArgErr;
		}
	}
	
	/*
	HRESULT CoInitializeEx(
	  void * pvReserved,  //Reserved
	  DWORD dwCoInit      //COINIT value
	);
	 */
	class Arg_CoInitializeEx extends Arg_property {
		private @_In Object pvReserved = null;
		private @_In int dwCoInit;
		
		Arg_CoInitializeEx(int dwCoInit){
			this.dwCoInit = dwCoInit;
		}
	}
	
	/*
	void CoUninitialize( );
	 */
	
	/*
	HRESULT CLSIDFromProgID(
	  LPCOLESTR lpszProgID,  //Pointer to the ProgID
	  LPCLSID pclsid         //Pointer to the CLSID
	);
	 */
	@_CharSet(CHARSET)
	class Arg_CLSIDFromProgID extends Arg_property {
		private @_In String lpszProgID;
		private @_Out Struct_IID pclsid;
		
		Arg_CLSIDFromProgID(String lpszProgID, Struct_IID pclsid){
			this.lpszProgID = lpszProgID;
			this.pclsid = pclsid;
		}
	}
	
	/*
	STDAPI CoCreateInstance(
	  REFCLSID rclsid,     //Class identifier (CLSID) of the object
	  LPUNKNOWN pUnkOuter, //Pointer to controlling IUnknown
	  DWORD dwClsContext,  //Context for running executable code
	  REFIID riid,         //Reference to the identifier of the interface
	  LPVOID * ppv         //Address of output variable that receives 
	                       // the interface pointer requested in riid
	);
	 */
	class Arg_propertyCCI extends Arg_property {
		private int _ElapsedTime;
		private double _ElapsedTimeQP;
	
		int getElapsedTime() {return _ElapsedTime;}
		double getElapsedTimeQP() {return _ElapsedTimeQP;}
	}

	class Arg_CoCreateInstance extends Arg_propertyCCI {
		private @_In Struct_IID rclsid;
		private @_In long pUnkOuter = 0;
		private @_In int dwClsContext;
		private @_In Struct_IID riid;
		private @_Out long[] ppv;
		
		Arg_CoCreateInstance(Struct_IID rclsid, int dwClsContext, Struct_IID riid, long[] ppv){
			this.rclsid = rclsid;
			this.dwClsContext = dwClsContext;
			this.riid = riid;
			this.ppv = ppv;
		}
	}
	
	/*
	HRESULT QueryInterface( 
		REFIID iid, 
		void **ppvObject
	);
	 */
	class Arg_QueryInterface extends Arg_property {
		private @_In Struct_IID iid;
		private @_Out long[] ppvObject;
		
		Arg_QueryInterface(Struct_IID iid, long[] ppvObject){
			this.iid = iid;
			this.ppvObject = ppvObject;
		}
	}
	
	/*
	ULONG Release(void);
	 */
	class Arg_Release extends Arg_property {
	}
	
	/*
	HRESULT GetIDsOfNames( 
	  REFIID  riid,                  
	  OLECHAR FAR* FAR*  rgszNames,  
	  unsigned int  cNames,          
	  LCID   lcid,                   
	  DISPID FAR*  rgDispId          
	);
	 */
	@_CharSet(CHARSET)
	class Arg_GetIDsOfNames extends Arg_property {
		private @_In Struct_IID riid;
		private @_In String[] rgszNames;
		private @_In int cNames;
		private @_In int lcid;
		private @_Out int[] rgDispId;
		
		Arg_GetIDsOfNames(Struct_IID riid, String[] rgszNames,
				int cNames, int lcid, int[] rgDispId){
			this.riid = riid;
			this.rgszNames = rgszNames;
			this.cNames = cNames;
			this.lcid = lcid;
			this.rgDispId = rgDispId;
		}
	}
	
	/*
	HRESULT Invoke( 
		DISPID dispIdMember, 
		REFIID riid,
		LCID lcid, 
		WORD wFlags, 
		DISPPARAMS FAR *pDispParams, 
		VARIANT FAR *pVarResult, 
		EXCEPINFO FAR *pExcepInfo, 
		unsigned int FAR *puArgErr
	);
	 */
	class Arg_Invoke extends Arg_property {
		private @_In int dispIdMember;
		private @_In Struct_IID riid;
		private @_In int lcid;
		private @_In short wFlags;
		private @_In @_Out Struct_DISPPARAMS pDispParams;
		private @_Out Struct_VARIANT pVarResult;
		private @_Out Struct_EXCEPINFO pExcepInfo;
		private @_Out int[] puArgErr;
		
		Arg_Invoke(int dispIdMember, Struct_IID riid, int lcid, short wFlags,
				Struct_DISPPARAMS pDispParams, Struct_VARIANT pVarResult,
				Struct_EXCEPINFO pExcepInfo, int[] puArgErr){
			this.dispIdMember = dispIdMember;
			this.riid = riid;
			this.lcid = lcid;
			this.wFlags = wFlags;
			this.pDispParams = pDispParams;
			this.pVarResult = pVarResult;
			this.pExcepInfo = pExcepInfo;
			this.puArgErr = puArgErr;
		}
	}
	
	/*
	HRESULT FindConnectionPoint(
	  REFIID riid,  //Requested connection point's interface identifier
	  IConnectionPoint **ppCP
	                //Address of output variable that receives the 
	                // IConnectionPoint interface pointer
	);
	 */
	class Arg_FindConnectionPoint extends Arg_property {
		private @_In Struct_IID riid;
		private @_Out long[] ppCP;
		
		Arg_FindConnectionPoint(Struct_IID riid, long[] ppCP){
			this.riid = riid;
			this.ppCP = ppCP;
		}
	}
	
	/*
	HRESULT Advise(
	  IUnknown *pUnk,  //Pointer to the client's advise sink
	  DWORD *pdwCookie //Pointer to the connection point identifier used 
	                   // by Unadvise
	);
	 */
	class Arg_Advise extends Arg_property {
		private @_In long pUnk;
		private @_Out int[] pdwCookie;
		
		Arg_Advise(long pUnk, int[] pdwCookie){
			this.pUnk = pUnk;
			this.pdwCookie = pdwCookie;
		}
	}
	
	/*
	HRESULT Unadvise(
	  DWORD dwCookie  //Connection token
	);
	 */
	class Arg_Unadvise extends Arg_property {
		private @_In int dwCookie;
		
		Arg_Unadvise(int dwCookie){
			this.dwCookie = dwCookie;
		}
	}
	
}
